import * as pulumi from "@pulumi/pulumi";
import * as pipelineConfig from "@data-heaving/pulumi-azure-pipeline-config";
export declare class ResourceProviderRegistration
  extends pulumi.dynamic.Resource
  implements ResourceOutputs
{
  readonly resourceProviderNamespaces: pulumi.Output<ReadonlyArray<string>>;
  constructor(
    provider: ResourceProviderRegistrationProvider,
    name: string,
    args: ResourceProviderRegistrationOptions,
    opts?: Omit<pulumi.CustomResourceOptions, "provider">,
  );
}
export interface ResourceProviderRegistrationOptions {
  resourceProviderNamespaces: pulumi.Input<ReadonlyArray<string>>;
}
declare type DynamicProviderInputs = {
  [P in keyof ResourceProviderRegistrationOptions]: ResourceProviderRegistrationOptions[P] extends pulumi.Input<
    infer T
  >
    ? T
    : never;
};
declare type DynamicProviderOutputs = DynamicProviderInputs;
declare type ResourceOutputs = {
  [P in keyof DynamicProviderInputs]: pulumi.Output<DynamicProviderInputs[P]>;
};
export declare class ResourceProviderRegistrationProvider
  implements pulumi.dynamic.ResourceProvider
{
  readonly tenantId: string;
  readonly subscriptionId: string;
  readonly auth: pipelineConfig.PipelineConfigAuth;
  readonly keyAndCertPath: string;
  constructor(
    tenantId: string,
    subscriptionId: string,
    auth: pipelineConfig.PipelineConfigAuth,
    keyAndCertPath: string,
  );
  create(inputs: DynamicProviderInputs): Promise<pulumi.dynamic.CreateResult>;
  check(
    olds: DynamicProviderInputs,
    news: DynamicProviderInputs,
  ): Promise<pulumi.dynamic.CheckResult>;
  diff(
    id: string,
    { resourceProviderNamespaces: nsOut }: DynamicProviderOutputs,
    { resourceProviderNamespaces: nsIn }: DynamicProviderInputs,
  ): Promise<pulumi.dynamic.DiffResult>;
  read(
    id: string,
    currentProps: DynamicProviderOutputs,
  ): Promise<pulumi.dynamic.ReadResult>;
  update(
    id: string,
    currentOutputs: DynamicProviderOutputs,
    newInputs: DynamicProviderInputs,
  ): Promise<pulumi.dynamic.UpdateResult>;
  delete(id: string, props: DynamicProviderOutputs): Promise<void>;
}
export {};
